// jQuery File Tree Plugin
//
// Version 1.01
//
// Cory S.N. LaViska
// A Beautiful Site (http://abeautifulsite.net/)
// 24 March 2008
//
// Visit http://abeautifulsite.net/notebook.php?article=58 for more information
//
// Usage: $('.fileTreeDemo').fileTree( options, callback )
//
// Options:  root           - root folder to display; default = /
//           script         - location of the serverside AJAX file to use; default = jqueryFileTree.php
//           folderEvent    - event to trigger expand/collapse; default = click
//           expandSpeed    - default = 500 (ms); use -1 for no animation
//           collapseSpeed  - default = 500 (ms); use -1 for no animation
//           expandEasing   - easing function to use on expand (optional)
//           collapseEasing - easing function to use on collapse (optional)
//           multiFolder    - whether or not to limit the browser to one subfolder at a time
//           loadMessage    - Message to display while initial tree loads (can be HTML)
//
// History:
//
// 1.01 - updated to work with foreign characters in directory/file names (12 April 2008)
// 1.00 - released (24 March 2008)
//
// TERMS OF USE
// 
// This plugin is dual-licensed under the GNU General Public License and the MIT License and
// is copyright 2008 A Beautiful Site, LLC. 
//
if(jQuery) (function($){
	
	$.extend($.fn, {
	
		//----------------------------
		//--这是将绑定到 <div id='jQueryFileTree'> 的 tree 函数入口
		//--o: 初始化参数 
		//--h: call back 函数 （点击了 file (而不是 folder) 之后 call back 的函数）
		//----------------------------
		fileTree: function(o, h) 
		{
			//----------------------------
			//--参数初始化
			//----------------------------
			if( !o ) var o = {};
			if( o.root == undefined ) o.root = '/';
			if( o.script == undefined ) o.script = 'jqueryFileTree.php';
			if( o.folderEvent == undefined ) o.folderEvent = 'click';
			if( o.expandSpeed == undefined ) o.expandSpeed= 500;
			if( o.collapseSpeed == undefined ) o.collapseSpeed= 500;
			if( o.expandEasing == undefined ) o.expandEasing = null;
			if( o.collapseEasing == undefined ) o.collapseEasing = null;
			if( o.multiFolder == undefined ) o.multiFolder = true;
			if( o.loadMessage == undefined ) o.loadMessage = 'Loading...';
			
			//----------------------------
			//--这里的 this 应该指的是 jQueryFileTree div （因为也个页面可以有多个 tree，因为这里用 each）
			//----------------------------
			$(this).each( function() 
			{
				//----------------------------
				//--显示 file tree
				//--c: container 
				//--t: root folder
				//----------------------------
				function showTree(c, t) 
				{
					//----------------------------
					//--首先在 cookie 中保存当前 t （注意：这里使用 unescape(t) 是因为调用 showTree() 的时候要先对 t 进行  escape 一次，而我们的 CommonSetCookie 本身里面就要 escape 过程）
					//----------------------------
					CommonSetCookie("CurrentTreeNode",unescape(t),1);
								
					//----------------------------
					//--在 container 上添加一个 wait class
					//----------------------------
					$(c).addClass('wait');
				
					//----------------------------
					//--关闭那个“正在加载...”消息
					//----------------------------
					$(".jqueryFileTree.start").remove();
					
					//----------------------------
					//--ajax
					//--o.script: ajax 发布的目标路径
					//--dir:t: ajax 发布的 form 数据
					//--function: ajax 返回数据的处理
					//----------------------------
					$.post(o.script, { dir: t }, function(data) 
					{
						//----------------------------
						//--这个似乎和上面的 $(".jqueryFileTree.start").remove(); 重复？
						//----------------------------
						$(c).find('.start').html('');
						
						//----------------------------
						//--将前面 addClass('wait') 添加到 class 去掉，同时，将 ajax 回来的数据注入当前 container
						//----------------------------
						if (unescape(t).match( /\<\%p\d+\%\>/)==null)
						{
							$(c).removeClass('wait').append(data);
						}
						else
						{
							$(c).removeClass('wait').empty();
							$(c).removeClass('wait').append(data);
						}						
						
						//----------------------------
						//--将 t （路径）上可能的 <%p3%> 一类的表示当前页码的字符串去掉
						//----------------------------
						var clean_t=escape(unescape(t).replace(/\<\%p\d+\%\>/i,""));						
						
						//----------------------------
						//--显示隐藏的 UL （这个 UL:hidden 的渊源：RetrieveResourceTree.aspx 中返回的 ajax 数据，那些 <li><a> 的总容器就是 <ul>，且是 display:none 的）
						//----------------------------
						//if( o.root == clean_t ) $(c).find('UL:hidden').show(); else $(c).find('UL:hidden').slideDown({ duration: o.expandSpeed, easing: o.expandEasing });
						if( o.root.toLowerCase() == clean_t.toLowerCase()) $(c).find('UL:hidden').show(); else $(c).find('UL:hidden').slideDown({ duration: o.expandSpeed, easing: o.expandEasing });

						//----------------------------
						//--注入了 ajax 数据的 container 进行 tree 刷新
						//----------------------------
						bindTree(c);
						
						//----------------------------
						//--定位到 cookie 中的 CurrentTreeNode 节点
						//----------------------------
						//for (var i=1; i<=aTreeNodesOnTheWay.length-1; i++)
						for (var i=1; i<=window.TreeNodesOnTheWay.length-1; i++)
						{
							//var sCurrentTreeNodeParent=escape(aTreeNodesOnTheWay[i-1]);			//因为 t 也 escape 了，所以这里 aTreeNodesOnTheWay[i-1] 也要 escape
							var sCurrentTreeNodeParent=escape(window.TreeNodesOnTheWay[i-1]);		//因为 t 也 escape 了，所以这里 aTreeNodesOnTheWay[i-1] 也要 escape
							//var sCurrentTreeNode=aTreeNodesOnTheWay[i];
							var sCurrentTreeNode=window.TreeNodesOnTheWay[i];
							var sCurrentTreeNodeSelector="A[rel='" + sCurrentTreeNode + "']";
							
							if (t.toLowerCase() == sCurrentTreeNodeParent.toLowerCase())
							{
								$(sCurrentTreeNodeSelector).parent().removeClass("expanded").addClass("collapsed"); 
								$(sCurrentTreeNodeSelector).click(); 	
							}							
						}						
					});
				}

				//----------------------------
				//--将 ajax 回来的内容绑定到 tree
				//--t: container div
				//----------------------------
				function bindTree(t) 
				{
					//----------------------------
					//--从 container div 中对所有 <li> 里面 的 <a> 进行处理
					//----------------------------
					$(t).find('LI A').bind(o.folderEvent, function() 
					{
						//----------------------------
						//--如果当前 <a> 的 parent （即 <li>） 是 directory 或 paging
						//----------------------------
						if( $(this).parent().hasClass('directory') ||  $(this).parent().hasClass('paging')) 
						{
							//----------------------------
							//--且是折叠的
							//----------------------------
							if( $(this).parent().hasClass('collapsed') ) 
							{
								//----------------------------
								//--是折叠的，就展开
								//----------------------------
								if( !o.multiFolder ) 
								{
									//----------------------------
									//--如果不是《多开式》，要先折叠全部 （折叠 <a> 的 parent <li> 的 parent <ul>）
									//----------------------------
									//$(this).parent().parent().find('UL').slideUp({ duration: o.collapseSpeed, easing: o.collapseEasing });
									$(this).parent().parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
									$(this).parent().parent().find('UL').remove();
									$(this).parent().parent().find('DIV').remove();
								}
								
								//----------------------------
								//--先清理旧的
								//----------------------------
								$(this).parent().find('UL').remove();

								//----------------------------
								//--在当前位置插入 ajax 回来的 tree （插入点就是当前 <li>，当前 folder 是 ajax 传递的那个 dir 的 rel 属性中缓存的 folder 路径）
								//----------------------------
								if ($(this).attr('rel').match( /\<\%p\d+\%\>/)==null)
								{
									showTree( $(this).parent(), escape($(this).attr('rel').match( /.*\// )) );
								}
								else
								{
									showTree( $(this).parent().parent(), escape($(this).attr('rel').match( /.*\// )) );
								}

								//----------------------------
								//--当前 <a> 的 parent <li> 标识为 《已展开》
								//----------------------------
								if ($(this).attr('rel').match( /\<\%p\d+\%\>/)==null)
								{
									$(this).parent().removeClass('collapsed').addClass('expanded');
								}
								else
								{
									$(this).parent().removeClass('collapsed').addClass('wait');
								}
							} 
							else 
							{
								//----------------------------
								//--是已经展开的，就折叠
								//----------------------------
								$(this).parent().find('UL').slideUp({ duration: o.collapseSpeed, easing: o.collapseEasing });
								$(this).parent().removeClass('expanded').addClass('collapsed');
							}
						} 
						else 
						{
							//----------------------------
							//--如果当前 <a> 的 parent （即 <li>） 是 file，则调用 file 函数 （当前 <a> 的 rel 属性中缓存的是当前文件路径）
							//----------------------------
							h($(this).attr('rel'));
						}
						return false;
					});
					
					//----------------------------
					//--Prevent A from triggering the # on non-click events
					//----------------------------
					if( o.folderEvent.toLowerCase() != 'click' ) $(t).find('LI A').bind('click', function() { return false; });
				}
								
				//----------------------------
				//--显示“正在加载...”消息
				//----------------------------
				$(this).html('<ul class="jqueryFileTree start"><li class="wait">' + o.loadMessage + '<li></ul>');				

				//----------------------------
				//--显示初始化 tree
				//----------------------------
				showTree( $(this), escape(o.root) );
			});
			
			
		}
	});
	
})(jQuery);